from django.forms import ModelForm
from .models import Product
from .models import Company
from .models import BuildOrder
from .models import TaskList
from .models import Alert
from django import forms
from .widgets import DatePickerInput, TimePickerInput, DateTimePickerInput


class ProductForm(ModelForm):
    product = forms.ModelChoiceField(queryset=Product.objects.values_list('product', flat=True).order_by('product'),
                                     empty_label='Select Product', label='')

    class Meta:
        model = Product
        fields = ('product',)


class CompanyForm(ModelForm):
    customer = forms.ModelChoiceField(queryset=Company.objects.values_list('customer', flat=True).order_by('customer'),
                                      empty_label='Select Customer', label='')

    class Meta:
        model = Company
        fields = ('customer',)


class OrderForm(ModelForm):
    class Meta:
        model = BuildOrder
        fields = (
            'order_num', 'customer', 'product', 'quantity', 'from_stock', 'to_make', 'original_pk', 'max_lead_time',
            'part_total')


class TaskListForm(ModelForm):
    class Meta:
        model = TaskList
        fields = (
            'item', 'order_num', 'customer', 'product', 'quantity', 'from_stock', 'to_make', 'start_on', 'original_pk',
            'max_lead_time', 'part_total', 'product_order', 'quantity_order', 'from_stock_order', 'to_make_order',
            'due_date', 'overdue_date', 'day_1', 'day_2', 'day_3', 'day_4', 'day_5', 'audio_alert_active',)


class CalendarForm(forms.Form):
    start_task = forms.DateField(widget=DatePickerInput, label='', required=True,
                                 input_formats=['%Y-%m-%d', '%Y/%m/%d'])
    # my_time_field = forms.TimeField(widget=TimePickerInput)
    # my_date_time_field = forms.DateTimeField(widget=DateTimePickerInput)


class AlertForm(forms.Form):
    class Meta:
        model = Alert
        field = ('audio_alert_active', 'touched',)
