from django.urls import path
from django.views.generic import TemplateView
from django.contrib import admin
from . import views


urlpatterns = [
    path("", views.landing, name='landing'),
    path("frontend/", views.frontend, name='frontend'),
    path("completed/", views.completed, name='completed'),
    path("products/", views.products, name='products'),
    path("jobcard/", views.jobcard, name='jobcard'),
    path("management/", views.management, name='management'),
    path("admin/", TemplateView.as_view(template_name=admin.site.urls), name='admin'),
    path("frontend/delete/<list_id>", views.delete, name='delete'),
    path("item_complete/<list_id>", views.item_complete, name='item_complete'),
    path("item_uncomplete/<list_id>", views.item_uncomplete, name='item_uncomplete'),
    path("task_complete/", views.task_complete, name='task_complete'),
    path("audio_alert/", views.audio_alert, name='audio_alert'),
]
