from django.shortcuts import render, redirect, reverse
from django.http import HttpResponseRedirect
from .models import Product
from .models import Company
from .models import BuildOrder
from .models import List
from .models import TaskList
from .models import Alert
from .forms import ProductForm
from .forms import CompanyForm
from .forms import OrderForm
from .forms import CalendarForm
from .forms import TaskListForm
from .forms import AlertForm
from django.contrib import messages
import datetime
from datetime import timedelta
from django.db.models import Sum, Max
import time


# from django.core.paginator import Paginator


def landing(req):
    all_tasks = TaskList.objects.all
    audio_alert = Alert.objects.all

    millisec_allowed = 0
    get_last_mod = Alert.objects.all()
    for mod_time in get_last_mod:
        allowed_audio = mod_time.last_touched + timedelta(minutes=5)
        millisec_allowed = str(allowed_audio.timestamp() * 1000).rpartition('.')[0]

    empty = 'There are no pending tasks'
    task = TaskList.objects.all()
    for order in task:
        if not order.completed:
            empty = ''
            break

    return render(req, "landing.html",
                  {"main_act1": "nav-link", "main_act2": "nav-link", "main_act3": "nav-link", "main_act4": "nav-link",
                   "main_act5": "nav-link", 'all_tasks': all_tasks, 'empty': empty, 'audio_alert': audio_alert,
                   'millisec_allowed': millisec_allowed})


def frontend(req):
    today = datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S")
    order_exists = TaskList.objects.values_list('order_num', flat=True)
    quantity_total = str(BuildOrder.objects.aggregate(Sum('quantity'))).rpartition(': ')[2].rpartition('}')[0]
    stock_total = str(BuildOrder.objects.aggregate(Sum('from_stock'))).rpartition(': ')[2].rpartition('}')[0]
    make_total = str(BuildOrder.objects.aggregate(Sum('to_make'))).rpartition(': ')[2].rpartition('}')[0]
    part_total = str(BuildOrder.objects.aggregate(Sum('part_total'))).rpartition(': ')[2].rpartition('}')[0]
    max_lead_time = str(BuildOrder.objects.aggregate(Max('max_lead_time'))).rpartition(': ')[2].rpartition('}')[0]
    product_order = str(BuildOrder.objects.all().count())
    productform = ProductForm()  # Product dropdown list
    companyform = CompanyForm()  # Company dropdown list
    calendarform = CalendarForm()
    all_ordered = BuildOrder.objects.all  # Order table
    ordered_products_iteration = BuildOrder.objects.all()
    all_products = Product.objects.all
    all_tasks = TaskList.objects.all

    show_flag = bool(req.GET.get('flag', False))
    # show_order = str(req.GET.get('order', False))
    # show_customer = str(req.GET.get('customer', False))

    try:
        current_order = BuildOrder.objects.all().last().order_num
        current_customer = BuildOrder.objects.all().last().customer
        companyform = CompanyForm(initial={'customer': str(current_customer)})
    except:
        if req.method == 'POST':
            pass
        else:
            pointer = 'visible'
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'all_ordered': all_ordered, 'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'all_tasks': all_tasks, 'order_exists': order_exists})

    pointer = 'none'
    if req.method == 'POST':
        form_ordered = OrderForm(req.POST or None)
        exist = 'no'
        product_exists = req.POST.get('product', '')
        for product in ordered_products_iteration:
            if str(product) in str(product_exists):
                exist = 'yes'

        from_stock_null = req.POST.get('from_stock', '')
        if not from_stock_null:
            updated_request = req.POST.copy()
            updated_request.update({'from_stock': 0})
            form_ordered = OrderForm(updated_request)

        if form_ordered.is_valid() and exist == 'no':
            form_ordered.save()

            current_order = BuildOrder.objects.all().last().order_num
            current_customer = BuildOrder.objects.all().last().customer
            companyform = CompanyForm(initial={'customer': str(current_customer)})
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'current_order': current_order, 'all_ordered': all_ordered, 'table_h_color': "table-success",
                           'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'order_exists': order_exists})

        form_tasklist = TaskListForm(req.POST or None)
        if form_tasklist.is_valid():
            how_many = BuildOrder.objects.all().count()
            from_start = str(req.POST.get('start_on', ''))
            from_due = str(req.POST.get('due_date', ''))
            from_lead = int(req.POST.get('max_lead_time', ''))
            new_due = datetime.datetime.strptime(from_due, "%Y-%m-%d") + datetime.timedelta(days=from_lead)
            new_overdue = datetime.datetime.strptime(from_due, "%Y-%m-%d") + datetime.timedelta(days=from_lead + 1)
            line_break = '<br>'

            date_list = []
            from_start_after = str(req.POST.get('start_on', '')).split('-')
            current = datetime.datetime(int(from_start_after[0]), int(from_start_after[1]), int(from_start_after[2]))
            end = datetime.datetime(int(from_start_after[0]), int(from_start_after[1]), int(from_start_after[2]))
            end += datetime.timedelta(days=45)
            while current < end:
                if current.weekday() < 5:
                    date_list.append(current.strftime("%Y-%m-%d"))
                current += datetime.timedelta(days=1)

            for value in BuildOrder.objects.all().order_by('-max_lead_time'):
                day_1 = day_2 = day_3 = day_4 = day_5 = 0
                if value.max_lead_time == 1:
                    day_1 = date_list[0]
                    new_due = date_list[1]
                    new_overdue = date_list[2]
                if value.max_lead_time == 2:
                    day_1 = date_list[0]
                    day_2 = date_list[1]
                    new_due = date_list[2]
                    new_overdue = date_list[3]
                if value.max_lead_time == 3:
                    day_1 = date_list[0]
                    day_2 = date_list[1]
                    day_3 = date_list[2]
                    new_due = date_list[3]
                    new_overdue = date_list[4]
                if value.max_lead_time == 4:
                    day_1 = date_list[0]
                    day_2 = date_list[1]
                    day_3 = date_list[2]
                    day_4 = date_list[3]
                    new_due = date_list[4]
                    new_overdue = date_list[5]
                if value.max_lead_time == 5:
                    day_1 = date_list[0]
                    day_2 = date_list[1]
                    day_3 = date_list[2]
                    day_4 = date_list[3]
                    day_5 = date_list[4]
                    new_due = date_list[5]
                    new_overdue = date_list[6]

                task_update_request = req.POST.copy()
                task_update_request.update({
                    'item': f'Order {value.order_num} for {value.customer} created on {today}.{line_break}Maximum lead time of the order is {max_lead_time} working day(s).',
                    'order_num': str(value.order_num), 'customer': str(value.customer),
                    'product': str(value.product), 'product_order': str(product_order),
                    'quantity': int(value.quantity), 'quantity_order': str(quantity_total),
                    'from_stock': int(value.from_stock),
                    'from_stock_order': str(stock_total),
                    'to_make': int(value.to_make), 'to_make_order': str(make_total),
                    'original_pk': str(value.original_pk),
                    'max_lead_time': int(value.max_lead_time), 'part_total': int(part_total),
                    'start_on': str(from_start), 'due_date': new_due, 'overdue_date': new_overdue,
                    'audio_alert_active': True, 'day_1': day_1,
                    'day_2': day_2, 'day_3': day_3, 'day_4': day_4, 'day_5': day_5})

                form_tasklist = TaskListForm(task_update_request)
                form_tasklist.save()

                if int(value.from_stock) > 0:
                    t = Product.objects.get(id=value.original_pk)
                    t.in_stock = int(t.in_stock) - int(value.from_stock)
                    t.save()

                time.sleep(0.5)
                if how_many > 0:
                    how_many -= 1
                    delete(req, value.pk)

            pointer = 'visible'
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'all_ordered': all_ordered, 'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'order_exists': order_exists})
        else:
            current_order = BuildOrder.objects.all().last().order_num
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'current_order': current_order, 'all_ordered': all_ordered, 'table_h_color': "table-danger",
                           'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'order_exists': order_exists})
    else:
        if show_flag:
            current_order = BuildOrder.objects.all().last().order_num
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'all_ordered': all_ordered, 'table_h_color': "table-warning", 'current_order': current_order,
                           'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'order_exists': order_exists})
        else:
            current_order = BuildOrder.objects.all().last().order_num
            return render(req, "frontend.html",
                          {"main_act1": "nav-link active", "main_act2": "nav-link", "main_act3": "nav-link",
                           "main_act4": "nav-link", "main_act5": "nav-link", 'productform': productform,
                           'companyform': companyform,
                           'all_ordered': all_ordered, 'table_h_color': "table-dark", 'current_order': current_order,
                           'pointer': pointer, 'all_products': all_products, 'today': today,
                           'quantity_total': quantity_total, 'stock_total': stock_total, 'make_total': make_total,
                           'calendarform': calendarform, 'order_exists': order_exists})


def completed(req):
    all_tasks = TaskList.objects.all
    show_filter = True
    ###################################################################### For Pagination
    # all_tasks_page = TaskList.objects.all()
    #
    # task_paginator = Paginator(all_tasks_page, 50)
    # page_num = req.GET.get('page')
    # page = task_paginator.get_page(page_num)
    # display_page = str(page).partition('<')[2].rpartition('>')[0]

    # return render(req, "completed.html",
    #               {"main_act1": "nav-link", "main_act2": "nav-link active", "main_act3": "nav-link",
    #                "main_act4": "nav-link", "main_act5": "nav-link", 'all_tasks': all_tasks,
    #                'all_task_all': all_tasks_page, 'task_count': task_paginator.count, 'page': page,
    #                'display_page': display_page})
    ########################################################################
    return render(req, "completed.html",
                  {"main_act1": "nav-link", "main_act2": "nav-link active", "main_act3": "nav-link",
                   "main_act4": "nav-link", "main_act5": "nav-link", 'all_tasks': all_tasks, 'show_filter': show_filter})


def products(req):
    all_products = Product.objects.all
    show_filter = True
    return render(req, "products.html",
                  {"main_act1": "nav-link", "main_act2": "nav-link", "main_act3": "nav-link active",
                   "main_act4": "nav-link", "main_act5": "nav-link",
                   'all_products': all_products, 'show_filter': show_filter})


def jobcard(req):
    all_tasks = TaskList.objects.all
    all_products = Product.objects.all
    calendarform = CalendarForm()

    job_date_full = datetime.datetime.now()
    job_date = job_date_full.strftime("%Y-%m-%d")

    if req.POST.get('start_on', ''):
        job_date = req.POST.get('start_on', '')

    return render(req, "jobcard.html",
                  {"main_act1": "nav-link", "main_act2": "nav-link", "main_act3": "nav-link",
                   "main_act4": "nav-link active",
                   "main_act5": "nav-link", 'calendarform': calendarform, 'all_tasks': all_tasks,
                   'all_products': all_products, 'job_date': job_date})


def management(req):
    return render(req, "management.html",
                  {"main_act1": "nav-link", "main_act2": "nav-link", "main_act3": "nav-link", "main_act4": "nav-link",
                   "main_act5": "nav-link active"})


def delete(req, list_id):
    all_ordered = BuildOrder.objects.get(pk=list_id)
    all_ordered.delete()

    try:
        initial_order = BuildOrder.objects.all().last().order_num
        current_customer = BuildOrder.objects.all().last().customer
        return redirect(f'{{}}?flag=True&order={initial_order}&customer={current_customer}'.format(reverse('frontend')))
    except:
        return redirect('frontend')


def item_complete(req, list_id):
    task_item = TaskList.objects.get(pk=list_id)
    task_item.task_item_completed = True
    task_item.save()

    alert = Alert.objects.all()
    for alert_status in alert:
        if alert_status.touched:
            alert_status.touched = False
        else:
            alert_status.touched = True
        alert_status.save()

    return redirect('landing')


def item_uncomplete(req, list_id):
    task_item = TaskList.objects.get(pk=list_id)
    task_item.task_item_completed = False
    task_item.save()

    alert = Alert.objects.all()
    for alert_status in alert:
        if alert_status.touched:
            alert_status.touched = False
        else:
            alert_status.touched = True
        alert_status.save()

    return redirect('landing')


def task_complete(req):
    if req.method == 'POST':
        inputtxt = req.POST['order_num']
        task = TaskList.objects.all()
        for order in task:
            if str(order.order_num) == str(inputtxt):
                order.task_item_completed = True
                order.audio_alert_active = False
                order.completed = True
                order.save()

    alert = Alert.objects.all()
    for alert_status in alert:
        if alert_status.touched:
            alert_status.touched = False
        else:
            alert_status.touched = True
        alert_status.save()

    return redirect('landing')


def audio_alert(req):
    if req.method == 'POST':
        input_audio = req.POST['audio_alert_active']
        alert = Alert.objects.all()
        task = TaskList.objects.all()
        for alert_status in alert:
            for order in task:
                if not order.completed:
                    alert_status.audio_alert_active = input_audio
                    alert_status.save()

    return redirect('landing')
